Check opam's health for the upcoming OCaml release (4.08)

opam
#1

Hi everyone,

Like last month, I’m here to announce new features and news from check.ocamllabs.io.

To recall, this website is an interface to find out which opam packages are broken with a given set of OCaml compilers. This month’s features are especially useful to look for missing or broken packages for the upcoming OCaml 4.08.

What’s new:

  • A new type of failures has appeared: internal failures (in white). Those were previously mistakenly categorized as a normal build failure but are usually far from it. It includes: solver failures, unavailable external dependencies, temporary misc server failures, …
  • Not available packages are now not skipped but have now logs attached to them. It makes the total check run longer but is extremely useful to understand why does packages are not available (e.g. which dependencies are blocking, …)

Minor features:

  • I have adopted a new name for the underlying tool: opam-health-check
  • Under advice from @kkazuo, @grayswandyr and @Ronan in the previous post, I have adopted a new colour palette less ambiguous to both colorblinds and non-colorblinds (at least I hope)
  • Slack integration (see more below)

What’s next:

  • Due to the ever growing number of opam packages and solver shenanigans, some solver failures can appear, especially on a server with a lot of packages building in parallel. For now opam-health-check uses the SYMPHONY solver instead of the builtin solver to mitigate that. However some failures still appear and I’m looking to use a custom branch of opam that uses Z3 instead.
  • I’m still meaning to add a revdeps counter soon as it is especially useful for new compiler releases (suggested by @bluddy a while ago, see previous post)
  • Discuss and email integration, to send a message every time a run has finished (every 3-4 days). For now only Slack has just been integrated.

As OCaml 4.08 will be somewhat soon released, I’m inviting everyone (especially maintainers), with some spare time and will power, to have a look at the main page with those filters:

Chase down non-available/broken opam packages for OCaml 4.08

For maintainers you can filter yourself and get only the packages you are maintaining, using the form for this purpose.

Happy hunt.

Side note: for now the diff page is going to show garbage data due to a server failure during the previous run

19 Likes

#2

@kit-ty-kate just to say that from a maintainer point of view the filter logic you provide is absolutely perfect. Thanks very much.

4 Likes

#3

What better way to say “this is awesome!” than…

thanks for the hard work on this @kit-ty-kate!

3 Likes